#include "roomsearchresultsmodel.h"

RoomSearchResultsModel::RoomSearchResultsModel()
{

}

int RoomSearchResultsModel::rowCount(const QModelIndex &parent) const
{
    return channelList.size();
}

QVariant RoomSearchResultsModel::data(const QModelIndex &index, int role) const
{
    int row = index.row();

    if ( channelList.isEmpty() || row > channelList.count() ) {
        return QVariant();
    }

    auto currentChannel = channelList.at( row );

    if ( role == name ) {
        return currentChannel->getName();
    }

    if ( role == roomId ) {
        return currentChannel->getRoomId();
    }

    if ( role == channelType ) {
        return currentChannel->getType();
    }

    if ( role == unreadMessages ) {
        return currentChannel->getUnreadMessages();
    }

    if ( role == readonly ) {
        return currentChannel->getReadOnly() || currentChannel->getArchived() || currentChannel->getBlocked();
    }

    if ( role == ownerId ) {
        return currentChannel->getOwnerName();
    }

    if ( role == ownerId ) {
        return currentChannel->getOwnerId();
    }

    if ( role == archived ) {
        return currentChannel->getArchived();
    }

    if ( role == blocked ) {
        return currentChannel->getBlocked();
    }
    if( role == username ){
        return currentChannel->getUsername();
    }

    return QVariant();

}

QHash<int, QByteArray> RoomSearchResultsModel::roleNames() const
{
    QHash<int, QByteArray> roles;
    roles[name] = QByteArrayLiteral( "name" );
    roles[roomId] =  QByteArrayLiteral( "roomId" );
    roles[unreadMessages] = QByteArrayLiteral( "unreadMessages" );
    roles[channelType] = QByteArrayLiteral( "type" );
    roles[readonly] = QByteArrayLiteral( "readonly" );
    roles[archived] = QByteArrayLiteral( "archived" );
    roles[blocked] = QByteArrayLiteral( "blocked" );
    roles[deleted] = QByteArrayLiteral( "deleted" );
    roles[ownerId] = QByteArrayLiteral( "ownerId" );
    roles[ownerName] = QByteArrayLiteral( "ownerName" );
    roles[username] = QByteArrayLiteral("username");

    return roles;
}

void RoomSearchResultsModel::clear()
{
    beginResetModel();
    channelList.clear();
    endResetModel();
}

void RoomSearchResultsModel::addChannels(const channelVector &pChannels)
{
    beginResetModel();
    channelList.clear();
    channelList << pChannels;
    endResetModel();
}
